﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using mVCI_CAN_DotNET;



namespace Demo1
{
    public partial class Form1 : Form
    {
        const int MODNUM = 2;
        byte[] ComPort = new byte[MODNUM];
        MVCI_SDK.PFN_UserDefISR pMyTestISR0, pMyTestISR1;
        UInt32 MyTest0_Val, MyTest1_Val;
        
        //Declare multi-module object for I-7565-H1/H2
        MVCI_SDK[] I7565H1H2_Mod = new MVCI_SDK[MODNUM];
        //MVCI_SDK[] I7565H1H2_Mod = new MVCI_SDK[MODNUM] { new MVCI_SDK(), new MVCI_SDK() };
        
        
        //[1] Global Functions
        string[] ErrMsg = 
        {
	        "No_Err",				"DEV_ModName_Err",			"DEV_ModNotExist_Err",
	        "DEV_PortNotExist_Err",	"DEV_PortInUse_Err", 		"DEV_PortNotOpen_Err",		
	        "CAN_ConfigFail_Err",	"CAN_HARDWARE_Err",			"CAN_PortNo_Err",			
	        "CAN_FIDLength_Err",	"CAN_DevDisconnect_Err",	"CAN_TimeOut_Err",			
	        "CAN_ConfigCmd_Err",	"CAN_ConfigBusy_Err",		"CAN_RxBufEmpty",
	        "CAN_TxBufFull"
        };

        public void ShowErrMsg(int ErrNo)
        {
            MessageBox.Show(ErrMsg[ErrNo], "", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        public UInt32 TPFLOATMS(double fVal)
        {
            return ((UInt32)(fVal*10)+100000000);
        }

        public void PortOpen_BtnFunc()
        {
            btn_OpenCAN.Enabled = false;
            cbo_ComPort.Enabled = false;
            cbo2_ComPort.Enabled = false;
            cbo_DevType.Enabled = false;
            cbo2_DevType.Enabled = false;
            cbo_C1Baud.Enabled = false;
            cbo_C2Baud.Enabled = false;
            cbo_CANNo.Enabled = true;
            btn_SendCANMsg.Enabled = true;
            btn_RecvCANMsg.Enabled = true;
            btn_EnHWCycTxMsg.Enabled = true;
            btn_DisHWCycTxMsg.Enabled = true;
            btn_CANStatus.Enabled = true;
            btn_ClrErrLED.Enabled = true;
            btn_ModInfo.Enabled = true;
            btn_RstMod.Enabled = true;
        }

        public void PortClose_BtnFunc()
        {
            btn_OpenCAN.Enabled = true;
            cbo_ComPort.Enabled = true;
            cbo2_ComPort.Enabled = true;
            cbo_DevType.Enabled = true;
            cbo2_DevType.Enabled = true;
            cbo_C1Baud.Enabled = true;
            if (cbo_DevType.SelectedIndex==0){
                cbo_C2Baud.Enabled = false;
            }
            else{
                cbo_C2Baud.Enabled = true;
            }
            //cbo_CANNo.Enabled = false;
            btn_SendCANMsg.Enabled = false;
            btn_RecvCANMsg.Enabled = false;
            btn_EnHWCycTxMsg.Enabled = false;
            btn_DisHWCycTxMsg.Enabled = false;
            btn_CANStatus.Enabled = false;
            btn_ClrErrLED.Enabled = false;
            btn_ModInfo.Enabled = false;
            btn_RstMod.Enabled = false;            
        }

        public void Show_CmdStatus(string Res)
        {
            this.lbl_CmdStatus.Text = "Cmd_Status :  " + Res;
        }



        //[2] Form Functions
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cbo_ComPort.SelectedIndex = 0;
            cbo2_ComPort.SelectedIndex = 0;
            cbo_DevType.SelectedIndex = 0;
            cbo2_DevType.SelectedIndex = 0;
            cbo_C1Baud.SelectedIndex = 14;
            cbo_C2Baud.SelectedIndex = 14;
            cbo_CANNo.SelectedIndex = 0;

            //cbo_CANNo.Enabled = false;
            btn_SendCANMsg.Enabled = false;
            btn_RecvCANMsg.Enabled = false;
            btn_EnHWCycTxMsg.Enabled = false;
            btn_DisHWCycTxMsg.Enabled = false;
            btn_CANStatus.Enabled = false;
            btn_ClrErrLED.Enabled = false;
            btn_ModInfo.Enabled = false;
            btn_RstMod.Enabled = false;

            Show_CmdStatus("Open CANPort First !!");

            //I-7565-H1/H2 Module Object InitDLL
            for (UInt32 i = 0; i < MODNUM; i++){
                I7565H1H2_Mod[i] = new MVCI_SDK();
                I7565H1H2_Mod[i].InitDLL();
            }
        }

        private void btn_OpenCAN_Click(object sender, EventArgs e)
        {
            int Ret=0;
            byte[] Mod_CfgData = new byte[512];

            //Listen Only Mode
            Mod_CfgData[0] = 0;                     //CAN1 => 0:Disable, 1:Enable
            Mod_CfgData[1] = 0;                     //CAN2 => 0:Disable, 1:Enable
            I7565H1H2_Mod[0].mVCI_Set_MOD_Ex(Mod_CfgData);

            ComPort[0] = (byte)(cbo_ComPort.SelectedIndex + 1);
            Ret = I7565H1H2_Mod[0].mVCI_OpenCAN_NoStruct(ComPort[0], (byte)(cbo_DevType.SelectedIndex + 1),
                (uint)(Convert.ToSingle(cbo_C1Baud.Text) * 1000),
                (uint)(Convert.ToSingle(cbo_C2Baud.Text) * 1000));
            if (Ret != 0)
                ShowErrMsg(Ret);
            else
            {
                Show_CmdStatus("Mod1_OpenCAN Success");
                PortOpen_BtnFunc();
            }

            ComPort[1] = (byte)(cbo2_ComPort.SelectedIndex + 1);
            Ret = I7565H1H2_Mod[1].mVCI_OpenCAN_NoStruct(ComPort[1], (byte)(cbo2_DevType.SelectedIndex + 1),
                 (uint)(Convert.ToSingle(cbo_C1Baud.Text) * 1000),
                 (uint)(Convert.ToSingle(cbo_C2Baud.Text) * 1000));
            //Ret = VCI_SDK.VCI_OpenCAN_NoStruct((byte)(cbo_ComPort.SelectedIndex + 1), (byte)(cbo_DevType.SelectedIndex+1),
            //    (uint)(Convert.ToSingle(cbo_C1Baud.Text) * 1000),
            //    (uint)(Convert.ToSingle(cbo_C2Baud.Text) * 1000));
            if (Ret != 0)
                ShowErrMsg(Ret);
            else
            {
                Show_CmdStatus("Mod2_OpenCAN Success");
                PortOpen_BtnFunc();
            }
        }

        private void btn_CloseCAN_Click(object sender, EventArgs e)
        {
            int Ret;

            for (int i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_CloseCAN(ComPort[i]);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                {
                    Show_CmdStatus("Mod" + (i+1) + "_CloseCAN" + (i + 1) + " Success");
                    PortClose_BtnFunc();
                }                
            }
        }

        private void cbo_DevType_SelectedIndexChanged(object sender, EventArgs e)
        {
            if(cbo_DevType.SelectedIndex==0){
                cbo_C2Baud.Enabled = false;
            }
            else{
                cbo_C2Baud.Enabled = true;
            }
        }

        private void btn_SendCANMsg_Click(object sender, EventArgs e)
        {
            int Ret;
            byte CAN_No, Mode, RTR, DLC;
            byte[] Data = new byte[8];
            UInt32 CANID;

            CAN_No = (byte)(cbo_CANNo.SelectedIndex+1);
            Mode = 0;
            RTR = 0;
            DLC = 8;
            CANID = 0x100;
            Data[0] = 0x12;
            Data[1] = 0x34;
            Data[2] = 0x56;
            Data[3] = 0x78;
            Data[4] = 0x90;
            Data[5] = 0xAB;
            Data[6] = 0xCD;
            Data[7] = 0xEF;

            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_SendCANMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID+i, Data);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                    Show_CmdStatus("Mod" + (i+1) + "_Send CAN" + CAN_No.ToString() + "_Msg OK");
            }
        }

        private void btn_RecvCANMsg_Click(object sender, EventArgs e)
        {
            int Ret;
            byte CAN_No, Mode, RTR, DLC;
            byte[] Data = new byte[8];
            UInt32 CANID, TH, TL, DL, DH;

            CAN_No = (byte)(cbo_CANNo.SelectedIndex + 1);
            Mode = RTR = DLC = 0;
            CANID = TH = TL = 0;
            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_RecvCANMsg_NoStruct(CAN_No, ref Mode, ref RTR, ref DLC, ref CANID, ref TL, ref TH, Data);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                {
                    unsafe
                    {
                        fixed (byte* pl = &Data[0], ph = &Data[4])
                        {
                            DL = *(UInt32*)pl;
                            DH = *(UInt32*)ph;
                        }
                    }
                    MessageBox.Show("[Mod" + (i + 1) + "]\n" +
                                    "Mode   => " + Mode + "\n" +
                                    "RTR    => " + RTR + "\n" +
                                    "DLC    => " + DLC + "\n" +
                                    "CANID  => 0x" + CANID.ToString("X") + "\n" +
                                    "Data_L => 0x" + string.Format("{0:X8}", DL) + "\n" +
                                    "Data_H => 0x" + string.Format("{0:X8}", DH) + "\n" +
                                    "Msg_Time => " + String.Format("{0:0.0000}", (double)((TH << 32) + TL) / 10000) + " (sec)");
                }
            }
        }

        private void btn_EnHWCycTxMsg_Click(object sender, EventArgs e)
        {
            int Ret;
            byte CAN_No, Mode, RTR, DLC;
            byte[] Data = new byte[8];
            UInt32 CANID;

            CAN_No = (byte)(cbo_CANNo.SelectedIndex + 1);
            Mode = 0;
            RTR = 0;
            DLC = 8;
            CANID = 0x335;
            Data[0] = 0x12;
            Data[1] = 0x34;
            Data[2] = 0x56;
            Data[3] = 0x78;
            Data[4] = 0x90;
            Data[5] = 0xAB;
            Data[6] = 0xCD;
            Data[7] = 0xEF;

            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID+i, Data, 10, 200);               //Send 200 CANMsg with 10ms period and Stop
                //Ret = I7565H1H2_Mod(i).mVCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, Data, TPFLOATMS(0.5), 200);   //Send 200 CANMsg with 0.5ms period and Stop
                //Ret = I7565H1H2_Mod(i).mVCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, Data, TPFLOATMS(2.5), 200);   //Send 200 CANMsg with 2.5ms period and Stop
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                    Show_CmdStatus("Mod" + (i+1) + "_HWCyclic SendCAN" + CAN_No + "Msg Start");
            }
        }

        private void btn_DisHWCycTxMsg_Click(object sender, EventArgs e)
        {
            int Ret;
            byte CAN_No;

            CAN_No = (byte)(cbo_CANNo.SelectedIndex + 1);
            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_DisableHWCyclicTxMsg();
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                    Show_CmdStatus("Mod" + (i+1) + "_HWCyclic SendCAN" + CAN_No + "Msg Stop");
            }
        }

        private void btn_RxMsgCnt_Click(object sender, EventArgs e)
        {            
            int Ret;
            byte CAN_No;
            UInt32 RxMsgCnt;

            RxMsgCnt = 0;
            CAN_No = (byte)(cbo_CANNo.SelectedIndex + 1);
            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_Get_RxMsgCnt(CAN_No, ref RxMsgCnt);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                    MessageBox.Show("Mod" + (i + 1) + "_CAN" + CAN_No + "RxMsgCnt= " + RxMsgCnt);
            }
        }

        private void btn_RxMsgBufIsFull_Click(object sender, EventArgs e)
        {
            int Ret;
            byte CAN_No, RxSoftBufFull_Flag;

            RxSoftBufFull_Flag = 0;
            CAN_No = (byte)(cbo_CANNo.SelectedIndex + 1);
            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_Get_RxMsgBufIsFull(CAN_No, ref RxSoftBufFull_Flag);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                    MessageBox.Show("Mod" + (i+1) + "_CAN" + CAN_No + "RxMsgBuf FullFlag= " + RxSoftBufFull_Flag);
            }
        }

        private void btn_ClrRxMsgBuf_Click(object sender, EventArgs e)
        {
            int Ret;
            byte CAN_No;

            CAN_No = (byte)(cbo_CANNo.SelectedIndex + 1);
            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_Clr_RxMsgBuf(CAN_No);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                    MessageBox.Show("Mod" + (i+1) + "_Clear CAN" + CAN_No + " RxSoftBuf OK");
            }
        }

        private void btn_DllVer_Click(object sender, EventArgs e)
        {
            UInt32 DllVer;

            DllVer = (UInt16)I7565H1H2_Mod[0].mVCI_Get_DllVer();
            MessageBox.Show("VCI_DllVer= v" + (byte)(DllVer>>8) + "." + string.Format("{0:00}", (byte)DllVer));
        }

        private void btn_ModInfo_Click(object sender, EventArgs e)
        {
            char[] ModID = new char[12];
            char[] FWVer = new char[12];
            char[] HWSN = new char[16];
            int Ret;

            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_Get_MODInfo_NoStruct(ModID, FWVer, HWSN);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                {
                    MessageBox.Show("Module" + (i + 1));
                    MessageBox.Show("ModName= " + new string(ModID));
                    MessageBox.Show("FW_Ver= " + new string(FWVer));
                    MessageBox.Show("HW_SN= " + new string(HWSN));
                }
            }
        }

        private void btn_RstMod_Click(object sender, EventArgs e)
        {
            int Ret;

            Show_CmdStatus("Waiting for Reset Module OK ...");
            for (UInt32 i = 0; i < MODNUM; i++)
            {
                I7565H1H2_Mod[i].mVCI_DoEvents();
                Ret = I7565H1H2_Mod[i].mVCI_Rst_MOD();
                if (Ret == 10)
                {
                    btn_CloseCAN_Click(sender, e);
                    MessageBox.Show("Mod" + (i+1) + "_Reset OK");
                }
                else
                    ShowErrMsg(Ret);
            }
        }

        private void btn_ClrErrLED_Click(object sender, EventArgs e)
        {
            int Ret;
            byte CAN_No;

            CAN_No = (byte)(cbo_CANNo.SelectedIndex + 1);
            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_Clr_BufOverflowLED(CAN_No);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                    MessageBox.Show("Mod" + (i+1) + "_Clear CAN" + CAN_No + "ErrLED OK");
            }
        }

        private void btn_CANStatus_Click(object sender, EventArgs e)
        {
            int Ret;
            byte CAN_No;
            UInt32 CurCANBaud;
            byte CANReg, CANTxErrCnt, CANRxErrCnt, ModState;

            CurCANBaud = CANReg = CANTxErrCnt = CANRxErrCnt = ModState = 0;
            CAN_No = (byte)(cbo_CANNo.SelectedIndex + 1);
            for (UInt32 i = 0; i < MODNUM; i++)
            {
                Ret = I7565H1H2_Mod[i].mVCI_Get_CANStatus_NoStruct(CAN_No, ref CurCANBaud, ref CANReg,
                                                        ref CANTxErrCnt, ref CANRxErrCnt, ref ModState);
                if (Ret != 0)
                    ShowErrMsg(Ret);
                else
                    MessageBox.Show("[Mod" + (i+1) + "]\n" + 
                                    "[CAN" + CAN_No + "_Status]\n" +
                                    "Baudrate: " + string.Format("{0:0000.000}", CurCANBaud / 1000) + " (Kbps)\n" +
                                    "Register: " + string.Format("0x{0:X2}\n", CANReg) +
                                    "TxErrCnt: " + string.Format("0x{0:X2}\n", CANTxErrCnt) +
                                    "RxErrCnt: " + string.Format("0x{0:X2}\n", CANRxErrCnt) +
                                    "ModState: " + string.Format("0x{0:X2}\n", ModState));
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            this.lbl_TimeStr.Text = "DateTime : " + System.DateTime.Now.ToString();
        }



        void MyTestISR0()
        {
            MyTest0_Val++;
            //MessageBox.Show("MyTestISR0");
        }

        void MyTestISR1()
        {
            MyTest1_Val++;
            //MessageBox.Show("MyTestISR1");
        }

        private void btn_Set_UserDefISR_Click(object sender, EventArgs e)
        {
            int Ret;

            MyTest0_Val = 0;
            MyTest1_Val = 0;

            /* Enable UserDefISR Function */
            //The UserDefISR (pMyTestISR0) will be trigged when receiving any one CANMsg
            pMyTestISR0 = new MVCI_SDK.PFN_UserDefISR(MyTestISR0);
            Ret = I7565H1H2_Mod[0].mVCI_Set_UserDefISR(MVCI_SDK.ISRNO_0, MVCI_SDK.ISR_CANPORT_ALL, MVCI_SDK.ISR_CANMODE_ALL, MVCI_SDK.ISR_CANID_ALL, pMyTestISR0);

            //The UserDefISR (pMyTestISR1) will be trigged when only receiving CANMsg with CANID=0x100
            pMyTestISR1 = new MVCI_SDK.PFN_UserDefISR(MyTestISR1);
            Ret = I7565H1H2_Mod[1].mVCI_Set_UserDefISR(MVCI_SDK.ISRNO_1, MVCI_SDK.CAN1, MVCI_SDK.MODE_11BIT, 0x100, pMyTestISR1);
            
            if (Ret != 0)
                ShowErrMsg(Ret);
            else
                Show_CmdStatus("Set_UserDefISR OK");
        }

        private void btn_Clr_UserDefISR_Click(object sender, EventArgs e)
        {
            /* Disable UserDefISR Function */
            I7565H1H2_Mod[0].mVCI_Clr_UserDefISR(MVCI_SDK.ISRNO_0);
            I7565H1H2_Mod[1].mVCI_Clr_UserDefISR(MVCI_SDK.ISRNO_1);

            MessageBox.Show("ISR0_Val=" + MyTest0_Val + ", ISR1_Val=" + MyTest1_Val);
        }

        private void btn_Get_ISRCANData_Click(object sender, EventArgs e)
        {
            byte ISR1_CANDataLen;
            byte[] ISR1_CANData = new byte[8];

            ISR1_CANDataLen = 0;
            I7565H1H2_Mod[1].mVCI_Get_ISRCANData(MVCI_SDK.ISRNO_1, ref ISR1_CANDataLen, ISR1_CANData);
            MessageBox.Show("ISR1_Data(" + ISR1_CANDataLen + ") = " + ISR1_CANData[0].ToString("X2") + "_" + ISR1_CANData[1].ToString("X2") + "_" + ISR1_CANData[2].ToString("X2") + "_" + ISR1_CANData[3].ToString("X2") + "_"
                             + ISR1_CANData[4].ToString("X2") + "_" + ISR1_CANData[5].ToString("X2") + "_" + ISR1_CANData[6].ToString("X2") + "_" + ISR1_CANData[7].ToString("X2"));
        }
        
    }
}