Imports VCI_CAN_DotNET

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbo_ComPort.SelectedIndex = 0
        cbo_DevType.SelectedIndex = 0
        cbo_C1Baud.SelectedIndex = 14
        cbo_C2Baud.SelectedIndex = 14
        cbo_CANNo.SelectedIndex = 0

        'cbo_CANNo.Enabled = False
        btn_SendCANMsg.Enabled = False
        btn_RecvCANMsg.Enabled = False
        btn_EnHWCycTxMsg.Enabled = False
        btn_DisHWCycTxMsg.Enabled = False
        btn_CANStatus.Enabled = False
        btn_ClrErrLED.Enabled = False
        btn_ModInfo.Enabled = False
        btn_RstMod.Enabled = False

        Show_CmdStatus("Open CANPort First !!")
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        lbl_TimeStr.Text = "DateTime : " + System.DateTime.Now.ToString()
    End Sub

    Private Sub cbo_DevType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbo_DevType.SelectedIndexChanged
        If cbo_DevType.SelectedIndex = 0 Then
            cbo_C2Baud.Enabled = False
        Else
            cbo_C2Baud.Enabled = True
        End If
    End Sub

    Private Sub btn_OpenCAN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenCAN.Click
        Dim Ret As Integer
        Dim Mod_CfgData(255) As Byte

        'Listen Only Mode
        Mod_CfgData(0) = 0                      'CAN1 => 0:Disable, 1:Enable
        Mod_CfgData(1) = 0                      'CAN2 => 0:Disable, 1:Enable
        VCI_SDK.VCI_Set_MOD_Ex(Mod_CfgData)

        Ret = VCI_SDK.VCI_OpenCAN_NoStruct((cbo_ComPort.SelectedIndex + 1), (cbo_DevType.SelectedIndex + 1), _
                                            (Convert.ToSingle(cbo_C1Baud.Text) * 1000), _
                                            (Convert.ToSingle(cbo_C2Baud.Text) * 1000))
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("OpenCAN Success")
            PortOpen_BtnFunc()
        End If
    End Sub


    Private Sub btn_CloseCAN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_CloseCAN.Click
        Dim Ret As Integer

        Ret = VCI_SDK.VCI_CloseCAN((cbo_ComPort.SelectedIndex + 1))
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("CloseCAN Success")
            PortClose_BtnFunc()
        End If

    End Sub

    Private Sub btn_CANStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_CANStatus.Click
        Dim Ret As Integer
        Dim CAN_No As Byte
        Dim CurCANBaud As Long
        Dim CANReg As Byte, CANTxErrCnt As Byte, CANRxErrCnt As Byte, ModState As Byte

        CurCANBaud = CANReg = CANTxErrCnt = CANRxErrCnt = ModState = 0
        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Ret = VCI_SDK.VCI_Get_CANStatus_NoStruct(CAN_No, CurCANBaud, CANReg, CANTxErrCnt, CANRxErrCnt, ModState)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            MessageBox.Show("[CAN" & CAN_No & "_Status]" & vbNewLine & _
                            "Baudrate: " & String.Format("{0:0000.000}", CurCANBaud / 1000) & " (Kbps)" & vbNewLine & _
                            "Register: " & String.Format("0x{0:X2}", CANReg) & vbNewLine & _
                            "TxErrCnt: " & String.Format("0x{0:X2}", CANTxErrCnt) & vbNewLine & _
                            "RxErrCnt: " & String.Format("0x{0:X2}", CANRxErrCnt) & vbNewLine & _
                            "ModState: " & String.Format("0x{0:X2}", ModState))
        End If
    End Sub

    Private Sub btn_ClrErrLED_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClrErrLED.Click
        Dim Ret As Integer
        Dim CAN_No As Byte

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Ret = VCI_SDK.VCI_Clr_BufOverflowLED(CAN_No)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            MessageBox.Show("Clear CAN" & CAN_No & "ErrLED OK")
        End If
    End Sub

    Private Sub btn_ModInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ModInfo.Click
        Dim ModID(11) As Char
        Dim FWVer(11) As Char
        Dim HWSN(15) As Char
        Dim Ret As Integer

        Ret = VCI_SDK.VCI_Get_MODInfo_NoStruct(ModID, FWVer, HWSN)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            MessageBox.Show("ModName= " + New String(ModID))
            MessageBox.Show("FW_Ver= " + New String(FWVer))
            MessageBox.Show("HW_SN= " + New String(HWSN))
        End If
    End Sub

    Private Sub btn_RstMod_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RstMod.Click
        Dim Ret As Integer

        Show_CmdStatus("Waiting for Reset Module OK ...")
        VCI_SDK.VCI_DoEvents()
        Ret = VCI_SDK.VCI_Rst_MOD()
        If Ret = 10 Then
            btn_CloseCAN_Click(sender, e)
            MessageBox.Show("Module Reset OK")
        Else
            ShowErrMsg(Ret)
        End If
    End Sub

    Private Sub btn_SendCANMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SendCANMsg.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, Mode As Byte, RTR As Byte, DLC As Byte
        Dim Data(8) As Byte
        Dim CANID As Long

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Mode = 0
        RTR = 0
        DLC = 8
        CANID = &H335
        Data(0) = &H12
        Data(1) = &H34
        Data(2) = &H56
        Data(3) = &H78
        Data(4) = &H90
        Data(5) = &HAB
        Data(6) = &HCD
        Data(7) = &HEF
        Ret = VCI_CAN_DotNET.VCI_SDK.VCI_SendCANMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, Data)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("Send CAN" + CAN_No.ToString() + "_Msg OK")
        End If
    End Sub

    Private Sub btn_RecvCANMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RecvCANMsg.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, Mode As Byte, RTR As Byte, DLC As Byte
        Dim Data(8) As Byte
        Dim CANID As Long, TH As Long, TL As Long
        Dim DL As String, DH As String

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Mode = RTR = DLC = 0
        CANID = TH = TL = 0
        Ret = VCI_CAN_DotNET.VCI_SDK.VCI_RecvCANMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, TL, TH, Data)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            DL = Strings.Right("00" & Hex(Data(3)), 2) & Strings.Right("00" & Hex(Data(2)), 2) & _
                Strings.Right("00" & Hex(Data(1)), 2) & Strings.Right("00" & Hex(Data(0)), 2)
            DH = Strings.Right("00" & Hex(Data(7)), 2) & Strings.Right("00" & Hex(Data(6)), 2) & _
                Strings.Right("00" & Hex(Data(5)), 2) & Strings.Right("00" & Hex(Data(4)), 2)
            MessageBox.Show("Mode   => " & Mode & vbNewLine & _
                            "RTR    => " & RTR & vbNewLine & _
                            "DLC    => " & DLC & vbNewLine & _
                            "CANID  => 0x" & CANID.ToString("X") & vbNewLine & _
                            "Data_L => 0x" & DL & vbNewLine & _
                            "Data_H => 0x" & DH & vbNewLine & _
                            "Msg_Time => " & String.Format("{0:0.0000}", (CSng(TH * 4294967296.0# + TL) / 10000)) & " (sec)")
        End If
    End Sub

    Private Sub btn_EnHWCycTxMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_EnHWCycTxMsg.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, Mode As Byte, RTR As Byte, DLC As Byte
        Dim Data(8) As Byte
        Dim CANID As Long

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Mode = 0
        RTR = 0
        DLC = 8
        CANID = &H335
        Data(0) = &H12
        Data(1) = &H34
        Data(2) = &H56
        Data(3) = &H78
        Data(4) = &H90
        Data(5) = &HAB
        Data(6) = &HCD
        Data(7) = &HEF

        Ret = VCI_SDK.VCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, Data, 10, 200)                '//Send 200 CANMsg with 10ms period and Stop
        'Ret = VCI_SDK.VCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, Data, TPFLOATMS(0.5), 200)    '//Send 200 CANMsg with 0.5ms period and Stop
        'Ret = VCI_SDK.VCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, Data, TPFLOATMS(2.5), 200)    '//Send 200 CANMsg with 2.5ms period and Stop
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("HWCyclic SendCAN" & CAN_No & "Msg Start")
        End If
    End Sub

    Private Sub btn_DisHWCycTxMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DisHWCycTxMsg.Click
        Dim Ret As Integer
        Dim CAN_No As Byte

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Ret = VCI_SDK.VCI_DisableHWCyclicTxMsg()
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("HWCyclic SendCAN" & CAN_No & "Msg Stop")
        End If
    End Sub

    Private Sub btn_RxMsgCnt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RxMsgCnt.Click
        Dim Ret As Integer
        Dim CAN_No As Byte
        Dim RxMsgCnt As Long

        RxMsgCnt = 0
        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Ret = VCI_SDK.VCI_Get_RxMsgCnt(CAN_No, RxMsgCnt)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            MessageBox.Show("CAN" & CAN_No & "RxMsgCnt= " & RxMsgCnt)
        End If
    End Sub

    Private Sub btn_RxMsgBufIsFull_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RxMsgBufIsFull.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, RxSoftBufFull_Flag As Byte

        RxSoftBufFull_Flag = 0
        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Ret = VCI_SDK.VCI_Get_RxMsgBufIsFull(CAN_No, RxSoftBufFull_Flag)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            MessageBox.Show("CAN" & CAN_No & "RxMsgBuf FullFlag= " & RxSoftBufFull_Flag)
        End If
    End Sub

    Private Sub btn_ClrRxMsgBuf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClrRxMsgBuf.Click
        Dim Ret As Integer
        Dim CAN_No As Byte

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Ret = VCI_SDK.VCI_Clr_RxMsgBuf(CAN_No)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            MessageBox.Show("Clear CAN" & CAN_No & " RxSoftBuf OK")
        End If
    End Sub

    Private Sub btn_DllVer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DllVer.Click
        Dim DllVer As Long

        DllVer = VCI_SDK.VCI_Get_DllVer()
        MessageBox.Show("VCI_DllVer= v" & ((DllVer >> 8) And &HFF) & "." & String.Format("{0:00}", (DllVer And &HFF)))
    End Sub

    Private Sub btn_Set_UserDefISR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Set_UserDefISR.Click
        Dim Ret As Integer        

        UserDefISR.MyTest0_Val = 0
        UserDefISR.MyTest1_Val = 0

        pMyTestISR0 = New VCI_SDK.PFN_UserDefISR(AddressOf MyTestISR0)
        pMyTestISR1 = New VCI_SDK.PFN_UserDefISR(AddressOf MyTestISR1)

        'Enable UserDefISR Function
        'The UserDefISR (pMyTestISR0) will be trigged when receiving any one CANMsg
        Ret = VCI_SDK.VCI_Set_UserDefISR(VCI_SDK.ISRNO_0, VCI_SDK.ISR_CANPORT_ALL, VCI_SDK.ISR_CANMODE_ALL, VCI_SDK.ISR_CANID_ALL, pMyTestISR0)

        'The UserDefISR (pMyTestISR1) will be trigged when only receiving CANMsg with CANID=0x100
        Ret = VCI_SDK.VCI_Set_UserDefISR(VCI_SDK.ISRNO_1, VCI_SDK.CAN1, VCI_SDK.MODE_11BIT, &H100, pMyTestISR1)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("Set_UserDefISR OK")
        End If
    End Sub

    Private Sub btn_Clr_UserDefISR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Clr_UserDefISR.Click
        'Disable UserDefISR Function */
        VCI_SDK.VCI_Clr_UserDefISR(VCI_SDK.ISRNO_0)
        VCI_SDK.VCI_Clr_UserDefISR(VCI_SDK.ISRNO_1)

        MessageBox.Show("ISR0_Val=" & MyTest0_Val & ", ISR1_Val=" & MyTest1_Val)
    End Sub

    Private Sub btn_Get_ISRCANData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Get_ISRCANData.Click
        Dim ISR1_CANDataLen As Byte
        Dim ISR1_CANData(8) As Byte

        VCI_SDK.VCI_Get_ISRCANData(VCI_SDK.ISRNO_1, ISR1_CANDataLen, ISR1_CANData)
        MessageBox.Show("ISR1_Data(" & ISR1_CANDataLen & ") = " & Hex(ISR1_CANData(0)) & "_" & Hex(ISR1_CANData(1)) & "_" & Hex(ISR1_CANData(2)) & "_" & Hex(ISR1_CANData(3)) & "_" & _
                         Hex(ISR1_CANData(4)) & "_" & Hex(ISR1_CANData(5)) & "_" & Hex(ISR1_CANData(6)) & "_" & Hex(ISR1_CANData(7)))

    End Sub

    Private Sub btn_VCI_EnableHWCyclicTxMsgNo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_VCI_EnableHWCyclicTxMsgNo.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, Mode As Byte, RTR As Byte, DLC As Byte, HW_TimerNo As Byte
        Dim Data(8) As Byte
        Dim CANID As Long

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Mode = 0
        RTR = 0
        DLC = 8
        CANID = &H335
        Data(0) = &H12
        Data(1) = &H34
        Data(2) = &H56
        Data(3) = &H78
        Data(4) = &H90
        Data(5) = &HAB
        Data(6) = &HCD
        Data(7) = &HEF

        'Send 200 CANMsg with 10ms period and Stop by using HWSendTimer-01
        HW_TimerNo = 1
        Ret = VCI_SDK.VCI_EnableHWCyclicTxMsgNo(CAN_No, Mode, RTR, DLC, CANID, Data, 10, 200, HW_TimerNo)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("HWTimer" & HW_TimerNo & "_SendCAN" & CAN_No & "Msg Start")
        End If

    End Sub

    Private Sub btn_VCI_EnableHWCyclicTxMsgNo_Ex_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_VCI_EnableHWCyclicTxMsgNo_Ex.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, Mode As Byte, RTR As Byte, DLC As Byte, HW_TimerNo As Byte
        Dim Data(8) As Byte
        Dim CANID As Long

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Mode = 0
        RTR = 0
        DLC = 8
        CANID = &H335
        Data(0) = &H0
        Data(1) = &H0
        Data(2) = &H0
        Data(3) = &H0
        Data(4) = &H0
        Data(5) = &H0
        Data(6) = &H0
        Data(7) = &H0

        'Send 200 CANMsg with 10ms period and Stop by using HWSendTimer-01
        'CANL_Data Value will be added by 1 every time
        'CANH_Data Value will be added by 2 every time
        HW_TimerNo = 1
        Ret = VCI_SDK.VCI_EnableHWCyclicTxMsgNo_Ex(CAN_No, Mode, RTR, DLC, CANID, Data, 10, 200, HW_TimerNo, VCI_SDK.ADDITION_MODE, 1, 2)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("HWTimer" & HW_TimerNo & "_SendCAN" & CAN_No & "Msg Start")
        End If

    End Sub

    Private Sub btn_VCI_DisableHWCyclicTxMsgNo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_VCI_DisableHWCyclicTxMsgNo.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, HW_TimerNo As Byte

        CAN_No = (cbo_CANNo.SelectedIndex + 1)

        'Stop HWSendTimer-01
        HW_TimerNo = 1
        Ret = VCI_SDK.VCI_DisableHWCyclicTxMsgNo(HW_TimerNo)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("HWTimer" & HW_TimerNo & "_SendCAN" & CAN_No & "Msg Stop")
        End If
    End Sub
End Class
